#include <iostream>
#include <vector>
using namespace std;

int main()
{
    int n, q;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> q;
    vector<int> br(n), pr(n);
    br[0] = 0;
    pr[0] = -1;
    int poslednji_break = 0;
    for (int i = 1; i < n; i++) {
        br[i] = br[i - 1];
        pr[i] = pr[i - 1];
        if (a[i] < a[i - 1]) {
            br[i]++;
            pr[i] = -1;
            poslednji_break = i;
        }
        if (poslednji_break != 0 && a[i] < a[poslednji_break - 1] && poslednji_break != i) { pr[i] = poslednji_break - 1; }

    }

    for (int i = 0; i < q; i++) {
        int l, d;
        cin >> l >> d;
        if (br[d - 1] > br[l - 1] + 1 || pr[d - 1] > l) { cout << "NE\n"; }
        else { cout << "DA\n"; }
    }
}